# Coveo FieldValue Component (CoveoFieldValue)

The FieldValue component displays the value of a field associated to its parent search result. It is normally usable within a FieldTable.

This component is a result template component (see Result Templates).

A common use of this component is to display a specific field value which also happens to be an existing Facet.options.field. When the user clicks on the FieldValue component, it activates the corresponding Facet.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- getValue
- renderOneValue
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- conditions
- displaySeparator
- facet
- field
- helper
- helperOptions
- htmlValue
- separator
- splitValues
- textCaption

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getValue

- getValue(): any

- - Defined in ui/FieldValue/FieldValue.ts :294

  Gets the current FieldValue from the current IQueryResult.

  #### Returns any

  The current FieldValue or `null` if value is and `Object`.

### renderOneValue

- renderOneValue(value: string): HTMLElement

- - Defined in ui/FieldValue/FieldValue.ts :307

  Renders a value to HTML using all of the current FieldValue component options.

  #### Parameters

  - ##### value: string

    The value to render.

  #### Returns HTMLElement

  The element containing the rendered value.

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### conditions

conditions: IFieldConditionOption[]

- Defined in ui/FieldValue/FieldValue.ts :225

A field-based condition that must be satisfied by the query result item for the component to be rendered.

Note: This option uses a distinctive markup configuration syntax allowing multiple conditions to be expressed. Its underlying logic is the same as that of the field value conditions mechanism used by result templates.

Examples: Render the component if the query result item's @documenttype field value is Article or Documentation.

    <div class="CoveoFieldValue" data-field="@author" data-condition-field-documenttype="Article, Documentation"></div>

Render the component if the query result item's @documenttype field value is anything but Case.

    <div class="CoveoFieldValue" data-field="@author" data-condition-field-not-documenttype="Case"></div>

Render the component if the query result item's @documenttype field value is Article, and if its @author field value is anything but Anonymous.

    <div class="CoveoFieldValue" data-field="@author" data-condition-field-documenttype="Article" data-condition-field-not-author="Anonymous"></div>

Default value is `undefined`.

### displaySeparator

displaySeparator: string

- Defined in ui/FieldValue/FieldValue.ts :131

If FieldValue.options.splitValues is `true`, specifies the string to use when displaying multi-value fields in the UI.

The component will insert this string between each value it displays from a multi-value field.

See also FieldValue.options.separator.

Default value is `", "`.

Only effective when

  `splitValues` is truthy

Default

  `,`

Markup configuration example(s) :

    data-display-separator='foo'

### facet

facet: string

- Defined in ui/FieldValue/FieldValue.ts :91

Specifies the Facet component to toggle when the end user clicks the FieldValue.

Default value is the value of FieldValue.options.field.

Note:

> If the target Facet.options.id is is not the same as its Facet.options.field), you must specify this option manually in order to link to the correct Facet.

Markup configuration example(s) :

    data-facet='foo'

### field

field: IFieldOption

- Defined in ui/FieldValue/FieldValue.ts :80

Specifies the field that the FieldValue should display.

Specifying a value for this parameter is required in order for the FieldValue component to work.

Required

  Specifying a value for this option is required for the component to work

Default

  `@field`

Markup configuration example(s) :

    data-field='@foo'

### helper

helper: string

- Defined in ui/FieldValue/FieldValue.ts :139

Specifies the helper that the FieldValue should use to display its content.

While several helpers exist by default (see ICoreHelpers), it is also possible for you to create your own custom helpers (see TemplateHelpers).

Markup configuration example(s) :

    data-helper='foo'

### helperOptions

helperOptions: any

- Defined in ui/FieldValue/FieldValue.ts :144

Specifies the options to call on the specified helper.

Minimum

  `0`

Default

  `true`

### htmlValue

htmlValue: boolean

- Defined in ui/FieldValue/FieldValue.ts :98

Specifies whether the content to display is an HTML element.

Default value is `false`.

Default

  `false`

Markup configuration example(s) :

    data-html-value='true'
    data-html-value='false'

### separator

separator: string

- Defined in ui/FieldValue/FieldValue.ts :119

If FieldValue.options.splitValues is `true`, specifies the separator string which separates multi-value fields in the index.

See FieldValue.options.displaySeparator.

Default value is `";"`.

Only effective when

  `splitValues` is truthy

Default

  `;`

Markup configuration example(s) :

    data-separator='foo'

### splitValues

splitValues: boolean

- Defined in ui/FieldValue/FieldValue.ts :109

Specifies whether to split the FieldValue at each FieldValue.options.separator.

This is useful for splitting groups using a Facet.options.field.

When this option is `true`, the displayed values are split by the FieldValue.options.displaySeparator.

Default value is `false`.

Default

  `false`

Markup configuration example(s) :

    data-split-values='true'
    data-split-values='false'

### textCaption

textCaption: string

- Defined in ui/FieldValue/FieldValue.ts :203

Specifies a caption to display before the value.

Default value is `undefined`.

Available since

  January 2017 Release (v1.1865.9)

Markup configuration example(s) :

    data-text-caption='foo'

## Constructors

### constructor

- new FieldValue(element: HTMLElement, options: IFieldValueOptions, bindings?: IComponentBindings, result?: IQueryResult, fieldValueClassId?: string): FieldValue

- Overwrites Component.constructor

  - Defined in ui/FieldValue/FieldValue.ts :232

  Creates a new FieldValue.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: IFieldValueOptions

    The options for the FieldValue component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  - ##### Default value fieldValueClassId: string = FieldValue.ID

  #### Returns FieldValue